/*
 * ASE1607.asm
 *
 *  Created: 21/09/2016 18.39.11
 *  Author: Roberto Roncella
 *  Compito del 14/09/2016
 *  Realizzare un programma per il microcontrollore AVR XMEGA256A3BU, che 
 *  a) inizializza prima la periferica di I/O nel modo seguente: 
 *     la porta virtuale 2 assume il ruolo della porta D 
 *     (con i 4 pin meno significativi in ingresso con pull-down e i 
 *      4 pin pi significativi in uscita wired-OR). 
 *     Ai pin in ingresso della porta D sono collegati esternamente pulsanti verso VDD, 
 *     mentre ai pin in uscita sono collegati gli anodi di LED 
 *     i cui catodi sono collegati a massa tramite una opportuna resistenza.
 *  b) poi legge continuamente lo stato dei pulsanti 
 *     e accende il LED corrispondente quando rileva la pressione di un pulsante 
 *     (il LED collegato al pin 4 corrisponde al pulsante sul pin 0, 5 a 1, 6 a 2, 7 a 3). 
 *
 */
.EQU PORTD_PIN_IN_value=0b00010000 //pull-down (b5_3=010)
.EQU PORTD_PIN_OUT_value=0b00100000 //wired-or (b5_3=100)
.EQU PORTD_DIR_value=0xF0 //pin 0..3 in ingresso e pin 4..7 in uscita
.EQU PIN_IN_MASK_value=0x0F //tutti i pin di ingresso da configurare allo stesso modo
.EQU PIN_OUT_MASK_value=0xF0 //tutti i pin di uscita da configurare allo stesso modo
.EQU VPCTRLB_value=0x03 //valore per configuare la porta virtuale su D (VPORT2)

Configure:
 ldi R16,PIN_IN_MASK_value
 ldi R17,PORTD_PIN_IN_value
 sts PORTCFG_MPCMASK,R16 //predispone la maschera dei pin di ingresso
 sts PORTD_PIN0CTRL,R17 //basta configurare un pin solo di quelli di ingresso
 ldi R16,PIN_OUT_MASK_value
 ldi R17,PORTD_PIN_OUT_value
 sts PORTCFG_MPCMASK,R16 //predispone la maschera dei pin di uscita
 sts PORTD_PIN4CTRL,R17 //basta configurare un pin solo di quelli di uscita
 ldi R16,PORTD_DIR_value
 sts PORTD_DIR,R16
 ldi R16,VPCTRLB_value
 sts PORTCFG_VPCTRLB,R16 //configura D nella porta virtuale 2

loop:
 in R16,VPORT2_IN //attenzione in debug: la lettura richiede almeno 2 cicli
 swap R16 //basta scambiare i digit
 out VPORT2_OUT,R16 //si puo` trascurare quanto va nei primi 4 bit
 rjmp loop //ripeti per sempre
